/*************************************
**function : Serial#1 Port RX, TX polling test 
           : CLOCK CONTROL-for 72MHz
**date     : 2012/11/1
**programmed by ksc
***************************************/
#include <stdint.h>
#include <stdio.h>
/***************************************
**define reset and clock control RCC
**RCC_base_address 0x40021000
***************************************/
#define RCC_CR_address        0x40021000  //clock control register
#define RCC_CFGR_address      0x40021004  //clock configuration register
#define RCC_CIR_address       0x40021008  //clock interrupt register
#define RCC_APB2RSTR_address  0x4002100C  //APB2 peripheral reset register
#define RCC_APB1RSTR_address  0x40021010  //APB1 peripheral reset register 
#define RCC_AHBENR_address    0x40021014  // AHB peripheral clock enable register
#define RCC_APB2ENR_address   0x40021018  // APB2 peripheral clock enable register
#define RCC_APB1ENR_address   0x4002101C  // APB1 peripheral clock enable register
#define RCC_BDCR_address   0x40021020     // backup domain control register
#define RCC_CSR_address   0x40021020      // control/status register
/********************************************
//Flash Memory Control
*********************************************/
#define Flash_ACR_address 0x40022000


/******************************************
**define GPIOA register address
**portA_base_address  0x40010c00
*******************************************/
#define GPIOA_CRL_address    0x40010800
#define GPIOA_CRH_address    0x40010804
#define GPIOA_IDR_address    0x40010808
#define GPIOA_ODR_address    0x4001080c
#define GPIOA_BSRR_address   0x40010810
#define GPIOA_BRR_address    0x40010814
#define GPIOA_CLKR_address   0x40010818

/******************************************
**define GPIOB register address
**portB_base_address  0x40010c00
*******************************************/
#define GPIOB_CRL_address    0x40010c00
#define GPIOB_CRH_address    0x40010c04
#define GPIOB_IDR_address    0x40010c08
#define GPIOB_ODR_address    0x40010c0c
#define GPIOB_BSRR_address   0x40010c10
#define GPIOB_BRR_address    0x40010c14
#define GPIOB_CLKR_address   0x40010c18

/******************************************************
** define USART register address
** USART base address : 0x4001 3800 - 0x4001 3BFF
*****************************************************/
#define USART_SR_address      0x40013800
#define USART_DR_address      0x40013804
#define USART_BRR_address     0x40013808
#define USART_CR1_address     0x4001380C
#define USART_CR2_address     0x40013810
#define USART_CR3_address     0x40013814

unsigned long   USART_STATE,RX_DATA;
main(){
/*************************************************************************/
// Initialize CLOCK Parameter
/*************************************************************************/  
(*(volatile unsigned *)RCC_CR_address)|=0x00010000;    //HSE ON enable
(*(volatile unsigned *)Flash_ACR_address)|=0x00000002; //set flash access latency
(*(volatile unsigned *)RCC_CFGR_address)|=0x00000400;  //PPRE2=0,PPRE1=/2,HPERE=0
(*(volatile unsigned *)RCC_CFGR_address)|=0x00110000; //PLL SOURCE =HSE, PLL XTPRE=0, PLLMUL= x6
(*(volatile unsigned *)RCC_CR_address)|=0x01010000;    //PLL enable
(*(volatile unsigned *)RCC_CIR_address)|=0x00000000;   // all clock interrupt disable
(*(volatile unsigned *)RCC_CFGR_address)|=0x00000002; //PLL selected as system clock

 /**********************************************************************/ 
(*(volatile unsigned *)RCC_APB2ENR_address)=0x400d;    //PortA,B USART clock enable

/**************************************************************************/
//PORTA : 9,10 bit 
//Bit9 :output mode , push-pull,50MHz
//bit10 : input mode floating
/**************************************************************************/
//1011 0000
(*(volatile unsigned *)GPIOA_CRH_address)=0x4b0;

//CNF : general purpose open drain output
//Mode : output mode(max speed : 50MHz)
(*(volatile unsigned *)GPIOB_CRL_address)=0x00700000; //set bit5 mode&cnf

//CNF : general purpose open drain output
//Mode : output mode(max speed : 50MHz)
(*(volatile unsigned *)GPIOB_CRH_address)=0x00000077; //set bit8,9 mode&cnf
/***************************************************************************/
// USART Initialize
// Baud-rate :57600
// data length :8 bit
// 1 stop bit
// No parity
// No hardware control
// TX,TX enable
/**************************************************************************/
//set baud rate 
(*(volatile unsigned *)USART_BRR_address)=0x4e2 ; 
//0010 0000 0000 1100
(*(volatile unsigned *)USART_CR1_address)=0x200C;    
(*(volatile unsigned *)USART_CR2_address)=0x00;
(*(volatile unsigned *)USART_CR3_address)=0x00;

//(*(volatile unsigned *)USART_DR_address)=0x30;
while(1){
if( (((*(volatile unsigned *)USART_SR_address)&0x20)>>5)==0x01)
{
  RX_DATA=(*(volatile unsigned *)USART_DR_address);
(*(volatile unsigned *)USART_DR_address)=RX_DATA+1;
//wait untill TXE=1
while( !(((*(volatile unsigned *)USART_SR_address)&0x80)>>7));      
}
}
}